/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.characterreplacementexample;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.IOException;
import java.io.StringReader;

/**
 *
 * @author omozegieaziegbe
 */
public class CharacterReplacementExample {

    public static Document parseXML(String xmlString) {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();

            // Parse the XML string
            InputSource inputSource = new InputSource(new StringReader(xmlString));
            Document document = builder.parse(inputSource);

            System.out.println("XML parsed successfully!");
            return document;
        } catch (ParserConfigurationException | IOException | org.xml.sax.SAXException e) {
            System.out.println("Failed to parse XML: " + e.getMessage());
            String cleanedXMLString = xmlString;
            System.out.println("Invalid characters in XML");
            System.out.println(cleanedXMLString);
            return null;
        }
    }

    public static void main(String[] args) {
        
        // Sample XML string with invalid characters
        //String xmlData = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><root><item>This is some text with invalid characters >: Core Java & Fundamentals</item></root>";

        //CDATA Section
        String xmlData = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><root><item><![CDATA[CDATA is useful for handling reserved characters like <, >, &, \\\", ' in XML.]]></item></root>";
        
        // Parse the XML data
        Document parsedXML = parseXML(xmlData);
    }
}
