/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.encodingconversionexample;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.io.*;
import org.xml.sax.InputSource;

/**
 *
 * @author omozegieaziegbe
 */
public class EncodingConversionExample {

    public static void main(String[] args) {
        
        // XML string with a non-Unicode character
        String xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
                            "<root>\n" +
                            "    <text>Non-Unicode Character: \u0004</text>\n" +
                            "</root>";

        // Parse XML using DOM
        parseXMLWithDOM(xmlString);
    }

    private static void parseXMLWithDOM(String xmlString) {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputSource is = new InputSource(new StringReader(xmlString));
            Document document = builder.parse(is);

            Element root = document.getDocumentElement();
            Node textNode = root.getElementsByTagName("text").item(0);
            String textContent = textNode.getTextContent();
            System.out.println("DOM Parsed Text Content: " + textContent);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}